<template>
  <v-app class="example-drag">
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>

    <!-- icon-top -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>

    <v-card class="example-drag">
      <v-container grid-list-xs>
        <div class="example-drag">
          <div class="upload">
            <div
              class="text-center p-5"
              style="border: 3px dashed rgba(28,110,164,0.42);height:175px"
            >
              <h4 class="mt-5">Drop files anywhere to upload<br />or</h4>
              <label
                style="display: none"
                for="file"
                ref="inputfile"
                class="btn btn-lg btn-primary"
                >Select Files</label
              >
              <v-btn
                for="file"
                rounded
                color="primary"
                dark
                @click="select_file()"
                >Select Files</v-btn
              >
              <br />
              <div class="mt-4">
                <span> <B>limit 100 Files / time</B> </span> &nbsp;&nbsp;
                <span>..,</span>
                <span style="color:red">
                  <B> Your files * : {{ length }} files </B>
                </span>
              </div>
            </div>
            <v-container fluid>
              <!-- <div justify="space-around">
                <v-row>
                  <v-col cols="12" sm="3">
                    <v-checkbox
                      input-value="true"
                      value="Ratina"
                      disabled
                      label="Ratina"
                      v-model="list_desease"
                    ></v-checkbox>
                  </v-col>
                </v-row>
              </div> -->
            </v-container>

            <v-data-table
              :headers="headers"
              :items="itemsWithIndex"
              :items-per-page="5"
              class="elevation-1"
            >
              <!-- <template v-slot:item.index="{ item }">
                <div>
                  {{ files.findIndex((x) => x.name === item.name) + 1 }}
                </div>
              </template> -->
              <template v-slot:item.progress="{ item }">
                <v-progress-linear
                  color="cyan darken-2"
                  height="15"
                  striped
                  :value="item.progress"
                  style="color:white"
                  >{{ item.progress }}%</v-progress-linear
                >
              </template>
              <template v-slot:item.success="{ item }">
                <v-icon v-if="item.error" color="error"
                  >mdi-alert-circle</v-icon
                >
                <v-icon v-else-if="item.success" color="teal">mdi-check</v-icon>
                <v-icon v-else color="error"></v-icon>
              </template>

              <template v-slot:item.active="{ item }">
                <v-tooltip top>
                  <template v-slot:activator="{ on, attrs }">
                    <v-icon
                      v-bind="attrs"
                      v-on="on"
                      color="error"
                      :disabled="item.progress > 0"
                      style="cursor:pointer"
                      @click="delete_item(item)"
                      >mdi-delete</v-icon
                    >
                  </template>
                  <span>Delete</span>
                </v-tooltip>
              </template>
            </v-data-table>

            <div
              v-show="$refs.upload && $refs.upload.dropActive"
              class="drop-active"
            >
              <h3>Drop files to upload</h3>
            </div>
            <!-- post-action="http://203.151.108.14:8000/api/v3/upload?hospital_id=12321&user_id=2165465" -->
            <div class="example-btn">
              <file-upload
                :headers="{ Authorization: token }"
                style="display: none"
                class="btn btn-primary"
                :post-action="api_upload"
                :multiple="true"
                :drop="true"
                :drop-directory="true"
                v-model="files"
                ref="upload"
                @input-file="inputFile"
              >
                <i class="fa fa-plus"></i>
                Select files
              </file-upload>

              <div style="text-align:right">
                <v-btn
                  class="mt-2"
                  type="button"
                  color="#3f51b5"
                  dark
                  v-if="!$refs.upload || !$refs.upload.active"
                  @click.prevent="start_upload"
                >
                  <v-icon>mdi-upload</v-icon>
                  Start Upload
                </v-btn>

                &nbsp;

                <v-btn
                  class="mt-2"
                  type="button"
                  color="error"
                  dark
                  style="width:180px"
                  @click.prevent="remove_all()"
                >
                  <v-icon>mdi-delete-sweep</v-icon>
                  Remove All
                </v-btn>
              </div>
            </div>
          </div>
        </div>
      </v-container>
    </v-card>
  </v-app>
</template>

<script>
import FileUpload from "vue-upload-component";

export default {
  name: "Upload",
  components: {
    FileUpload
  },
  data() {
    return {
      api: "https://1ls.manageai.co.th",
      // api: "https://1ls-demo.manageai.co.th",
      // api: "http://localhost:8080",
      token: this.$cookies.get("info_login").session_id,
      fab: false,
      length: "0",
      list_desease: ["Ratina"],
      res_info_upload: [],
      dialog_loader: false,
      four: [],
      //checkbox
      Tuberculosis: "Tuberculosis",
      Abnormal: "Abnormal",
      Pneumothorax: "",
      Emphtsema: "",
      Pneumonia: "",
      //value-checkbox
      valuePneumothorax: "",
      valueEmphtsema: "",
      valuePneumonia: "",
      //
      info_login: "",
      api_upload: "",
      files: [],
      limit_file: 100,
      headers: [
        {
          text: "No.",
          align: "start",
          value: "index"
        },
        { text: "File name", value: "name", align: "center" },
        { text: "Progress", value: "progress", align: "center" },
        { text: "Status", value: "success", align: "center" },
        { text: "Action", value: "active", align: "center" }
      ]
    };
  },
  watch: {
    files(val) {
      console.log(val);
      // console.log("val.length =====>>", val.length);
      if (val.length <= this.limit_file) {
        this.length = val.length;
        // console.log("test");
        for (let index = 0; index < val.length; index++) {
          // console.log(val[index].type);
          // console.log(val[index].name);
          if (
            val[index].type == "image/png" ||
            val[index].type == "image/jpeg"
          ) {
            continue;
          } else {
            // this.files = [];
            this.files.splice(val.length - 1, 1);
            this.$swal({
              icon: "warning",
              title: "Warning!",
              text: "Type file incorrect.",
              confirmButtonText: "OK",
              allowOutsideClick: false
            });
            break;
          }
        }
      } else {
        var delect_length = val.length - this.limit_file;
        this.$swal({
          icon: "warning",
          title: "Warning!",
          text: "100 files limit only.",
          confirmButtonText: "OK",
          allowOutsideClick: false
        }).then(() => {
          this.files.splice(val.length - delect_length, delect_length);
        });
      }
      var list_success = [];
      for (let index = 0; index < val.length; index++) {
        console.log(val[index].success);
        if (val[index].success == true) {
          list_success.push(true);
          if (list_success.length == val.length) {
            // localStorage.setItem("four", JSON.stringify(this.list_desease));
            // this.$store.commit("setDisease", this.list_desease);
            this.$store.commit("setUpload_id", this.res_info_upload);
            this.dialog_loader = true;
            setTimeout(() => {
              this.$router.push("/display");
              this.dialog_loader = false;
            }, 2000);
          }
        }
      }
    }
  },
  mounted() {
    this.info_login = this.$cookies.get("info_login");
    // ===> production <=== //
    // this.api_upload = `https://1ls.manageai.co.th/api/v3/upload_retina?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
    // ===> demo <=== //
    // this.api_upload = `https://1ls-demo.manageai.co.th/api/v3/upload_retina?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
    // this.api_upload = `https://1ls-demo.manageai.co.th/api/v3/upload?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
    // ===> localhost <=== //
    this.api_upload = this.api+`/api/v3/upload_retina?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
    // this.api_upload = `http://203.151.108.14:8007/api/v3/upload_retina?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
  },

  computed: {
    itemsWithIndex() {
      return this.files.map((files, index) => ({
        ...files,
        index: index + 1
      }));
    }
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    inputFile: function(newFile, oldFile) {
      if (newFile && oldFile && !newFile.active && oldFile.active) {
        // Get response data
        // console.log("response-backend", newFile.response);
        // console.log("response-active", newFile);
        // if (newFile.response.status == "fail") {
        //   for (let index = 0; index < this.res_info_upload.length; index++) {
        //     console.log("status", newFile.xhr.status);
        //     if (newFile.xhr.status == 401) {
        //       this.$swal({
        //         icon: "error",
        //         title: "Error!",
        //         text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
        //         confirmButtonText: "OK",
        //         allowOutsideClick: false
        //       }).then(() => {
        //         this.dialog_loader = false;
        //         window.location.href = this.api;
        //       });
        //       break;
        //     }
        //   }
        // }
        // console.log("response-active", newFile.active);
        // console.log("upload_id", newFile.response.upload_id);
        this.res_info_upload.push(newFile.response.upload_retina_id);
        // console.log("res==>info_login===>)", this.res_info_upload);
        // if (newFile.xhr) {
        //   //  Get the response status code
        //   console.log("status", newFile.xhr.status);
        // }
      }
    },

    select_file() {
      // this.$refs.inputfile;
      this.$refs.inputfile.click();
      // console.log(this.$refs.inputfile);
    },

    // delete_item(item) {
    //   const index = this.files.indexOf(item);
    //   this.files.splice(index, 1);
    // },

    delete_item(item) {
      console.log(item);
      const index = this.itemsWithIndex.indexOf(item);
      this.files.splice(index, 1);
    },

    start_upload() {
      this.$refs.upload.active = true;
      console.log(this.files);
      for (let index = 0; index < this.files.length; index++) {
        if (this.files[index].success == false) {
          console.log("if");
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            this.dialog_loader = false;
            window.location.href = this.api;
          });
          break;
        }
      }
    },

    remove_all() {
      // $refs.upload.active = false && files == []
      this.files = [];
    }
  }
};
</script>

<style>
.example-drag label.btn {
  margin-bottom: 0;
  margin-right: 1rem;
}
.example-drag .drop-active {
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  position: fixed;
  z-index: 9999;
  opacity: 0.6;
  text-align: center;
  background: #000;
}
.example-drag .drop-active h3 {
  margin: -0.5em 0 0;
  position: absolute;
  top: 50%;
  left: 0;
  right: 0;
  -webkit-transform: translateY(-50%);
  -ms-transform: translateY(-50%);
  transform: translateY(-50%);
  font-size: 40px;
  color: #fff;
  padding: 0;
}
</style>
